#pragma once

#include <iostream>
#include <exception>

/// t3 = t1 + t2
/// t1 += t2
/// t1 = ~t2 , zameni x i y
/// t1++, inkrementira x i y
/// ++t1
/// 
/// t1['x'] t1['y']
/// cout<<t1;
class Tacka
{
private:
	double x, y;
public:
	Tacka(double x = 0.0, double y = 0.0) :x(x), y(y) {
	}

	Tacka(const Tacka& t) = default;
	Tacka(Tacka&& t) = default;
	Tacka& operator=(const Tacka&) = default;
	Tacka& operator=(Tacka&&) = default;

	friend Tacka operator+(const Tacka&, const Tacka&);

	Tacka& operator+=(const Tacka& t) {
		x += t.x;
		y += t.y;
		return *this;
	}

	Tacka operator~() {
		return Tacka(y, x);
	}

	Tacka operator++(int) {
		Tacka ret(*this);
		x++;
		y++;
		return ret;
	}

	Tacka& operator++() {
		x++;
		y++;
		return *this;
	}

	double& operator[](char c) {
		switch (c)
		{
		case 'x': return x;
		case 'y': return y;
		default:
			throw std::exception("Wrong argument value");
			break;
		}
	}

	friend std::ostream& operator<<(std::ostream&, const Tacka&);

	friend std::istream& operator>>(std::istream&, Tacka&);



	double getX() const {
		return x;
	}

	double getY() const {
		return y;
	}

	void pisi() const {
		std::cout << "(" << x << ", " << y << ")";
	}
};

